function onLoad()
{
	loadTags();
}

function loadTags()
{
	try
	{
	    const tagsList = document.getElementById('delicious-sidebar-tagsList');
		const xmlDOM = deliciousService.getTags();
	    
	    var root = xmlDOM.documentElement;
	    var myTags = root.getElementsByTagName("tag");
	        
	    for (var i = 0; i < myTags.length; i++) 
	    {
	        var tagName = myTags[i].getAttribute("tag");
	        
	        tagsList.appendItem(tagName, tagName);
	    }
	}
	catch(e)
	{
		alert(e);
	}
}


function reloadTags()
{
    const tagsList = document.getElementById('delicious-sidebar-tagsList');
	var itemCount = tagsList.getRowCount();
	
	for (i = 0; i < itemCount; i++)
	{
		tagsList.removeItemAt(i);
	}
	
	loadTags();
}

function clearFeeds()
{
	var tree = document.getElementById('delicious-sidebar-tree');

	var datasources = tree.database.GetDataSources();
	while(datasources.hasMoreElements()){
	        var datasource = datasources.getNext();
	        datasource = datasource.QueryInterface(Components.interfaces.nsIRDFDataSource);
	        tree.database.RemoveDataSource(datasource);
	}

//    tree.database.RemoveDataSource(ds);
//    rdf.UnregisterDataSource(ds);

	tree.builder.rebuild();
}

function reloadFeeds()
{
	var tree = document.getElementById('delicious-sidebar-tree');
	var datasources = tree.database.GetDataSources();
	
	alert("Reload is not working currently. 304 HTTP code is not handled correctly by Mozilla.\nWorking on a fix.");
	while(datasources.hasMoreElements()){
	        var datasource = datasources.getNext();
	        datasource = datasource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
	        // reload asyncronously. does not seem to know what 304 is
	        datasource.Refresh(false);
	}
}

//
// Displays the selected tags
//
function loadSelectedTag()
{
    const tagsList = document.getElementById('delicious-sidebar-tagsList');

    if(tagsList.selectedCount == 0)
    {
        alert("Click on a tag");
        return false;
    }
    else
    {
    	loadFeed(tagsList.selectedItem.value);
    }

}

//
//
//
function loadFeed(tag)
{
	try
	{
		var username = deliciousService.getUsername();
		var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
		var feedUrl = "http://del.icio.us/rss/" + username;
		
		if(tag != null)
		{
			feedUrl += "/" + tag;
		}
		
		var datasource = rdfService.GetDataSource(feedUrl);
		
		var tree = document.getElementById('delicious-sidebar-tree');
		
		// This has to match the channel in the feed
		tree.ref = "http://del.icio.us/" + username;
		tree.database.AddDataSource(datasource);
		tree.builder.rebuild();
	}
	catch(e)
	{
		alert(e);
	}
}